/*
 * Copyright 2008 Sony Corporation
 *
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include <mars/task.h>
#include <mars_task_test.h>
#include <spu_mfcio.h>

static uint32_t shared_resource __attribute((aligned(16)));

int mars_task_main(const struct mars_task_args *task_args)
{
	int ret;
	uint64_t mpu_to_mpu_ea = task_args->type.u64[0];
	uint32_t chk_bit = (uint32_t)task_args->type.u64[1];
	uint64_t shared_resource_ea = task_args->type.u64[2];

	ret = mars_task_event_flag_wait(
		mpu_to_mpu_ea,
		chk_bit,
		MARS_TASK_EVENT_FLAG_MASK_AND, NULL);
	 MARS_TEST_ASSERT_ERROR(ret, MARS_SUCCESS);

	/* if program reaches here, shared_resource'll be updated */
	shared_resource = 1;
	mfc_put(&shared_resource, shared_resource_ea,
		sizeof(uint32_t), 0, 0, 0);
	mfc_write_tag_mask(1 << 0);
	mfc_read_tag_status_all();

	return 0;
}
